// How big is it? UVa 10012

// On genere toutes les permutations, et pour chaque permutation on teste la
// taille de la boite necessaire.

#include <iostream>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>

int perm[8]; // permutation en cours
int n; // nombre de cas
int m; // nombre de cercles
double rayons[8]; // rayons des cercles
double *rangement[8];

// position du centre du cercle 2 lorsqu'on le colle au cercle 1
double deux_cercle_tangents(double centre1, double rayon1, double rayon2)
{
  double t = 2*sqrt(rayon1*rayon2)+centre1;
  // mais on peut toucher le bord gauche de la boite
  if (t<rayon2)
    t = rayon2;
  return t;
}

// place un cercle de rayon donne a la suite d'une succession de cercles deja
// places
double rangt_partiel(double **cercles, double rayon, int nombre)
{
  double s = 0;
  double t;
  for (int i=0; i<nombre; ++i)
    {
      t = deux_cercle_tangents(cercles[i][0], cercles[i][1], rayon);
      if (t>s)
	s = t;
    }
  return s;
}

// calcule la taille d'un rangement
double taille_rangement()
{
  rangement[0][0] = rangement[0][1] = rayons[perm[0]];
  double taille=2*rangement[0][0];
  for (int i=1; i<m; ++i)
    {
      rangement[i][1] = rayons[perm[i]];
      rangement[i][0] = rangt_partiel(rangement, rayons[perm[i]], i);
      if (taille < rangement[i][0]+rangement[i][1])
	taille = rangement[i][0]+rangement[i][1];
    }
  return taille;
}

// pour qsort (utilise dans permut_suivante)
int comparaison(const void *x, const void *y)
{
  return *((int *) x)-*((int *) y);
}

// genere la permutation suivante selon l'ordre lexico
bool permut_suivante()
{
  int i=m-2;
  while (i>=0 && perm[i] > perm[i+1])
    --i;

  if (i < 0)
    return false;

  int min=m+1, j0;

  for (int j=m-1; j>i; --j)
    if (min > perm[j] && perm[j] > perm[i])
      {
	min = perm[j];
	j0 = j;
      }

  int t = perm[j0];
  perm[j0] = perm[i];
  perm[i] = t;

  qsort(&perm[i+1], m-i-1, sizeof(int), comparaison);
  return true;
}

int main()
{

  double taille, meilleur;

  for (int i=0; i<8; ++i)
    rangement[i] = (double *) malloc(2*sizeof(double));

  std::cin >> n;

  for (int p=0; p<n; ++p)
    {
      std::cin >> m;

      // commence par l'identite et recherche le meilleur rangement
      for (int i=0; i<m; ++i)
	{
	  perm[i] = i;
	  std::cin >> rayons[i];
	}
      
      meilleur = taille_rangement();
      while (permut_suivante())
	{
	  taille = taille_rangement();
	  if (taille < meilleur)
	    meilleur=taille;
	}
      printf("%1.3f\n", meilleur);
    }


}
