// Rope crisis in Ropeland! UVa 10180

// On determine si le segment coupe le cercle. Si oui, on calcule la longueur
// des segments tangents, et les angles qu'ils forment ; on etudie 4 cas et on
// prend le min. Sinon, on renvoie la distance entre les deux points.

#include <iostream>
#include <math.h>
#include <stdio.h>

#define PI 3.1415926536
#define EPSILON 10e-20

// pour determiner si le segment coupe le cercle, on resoud une equation de
// degre 2 et on teste si une solution est dans l'intervalle ]0,1[
bool segment_inter_cercle(double x1, double x2, double y1, double y2, double r)
{
  double a = (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2);
  double b = x1*x2+y1*y2-x1*x1-y1*y1;
  double c = x1*x1+y1*y1-r*r;
  double delta = b*b-a*c;

  if (delta >= 0)
    {
      double s1 = (-b+sqrt(delta))/a;
      double s2 = (-b-sqrt(delta))/a;
      if (((0 < s1) && (s1 < 1)) || ((0 < s2) && (s2 < 1)))
	return true;
      // cas particuliers degeneres (une equipe sur la frontiere du poteau)
      if (((fabs(s1)<EPSILON)||(fabs(s1-1)<EPSILON))&&((0 <= s2) && (s2 <= 1)))
	return true;
      if (((fabs(s2)<EPSILON)||(fabs(s2-1)<EPSILON))&&((0 <= s1) && (s1 <= 1)))
	return true;
    }
  return false;
}

int signe(double x)
{
  if (x>=0)
    return 1;
  return -1;
}

// ajouter des angles modulo 2pi
// tous nos angles sont dans [-pi, pi[
double plus(double a, double b)
{
  double c = a+b;
  if (c>=PI)
    c -= 2*PI;
  else
    if (c<-PI)
      c += 2*PI;
  return c;
}

// calcule le min des quatre cas
double calcule_longueur(double x1, double x2, double y1, double y2, double r)
{
  // carre de la distance de (x1,y1) a l'origine
  double d1 = x1*x1+y1*y1;
  // carre de la distance de (x2,y2) a l'origine
  double d2 = x2*x2+y2*y2;
  // longueur tangente passant par (x1,y1)
  double tangente1 = sqrt(d1-r*r);
  // longueur tangente passant par (x2,y2)
  double tangente2 = sqrt(d2-r*r);
  // angle entre (x1,y1) et l'axe des abscisses
  double theta1 = signe(y1)*acos(x1/sqrt(d1));
  // angle entre (x2,y2) et l'axe des abscisses
  double theta2 = signe(y2)*acos(x2/sqrt(d2));
  // angle avec la tangente de (x1,y1)
  double phi1 = acos(r/sqrt(d1));
  // angle avec la tangente de (x2,y2)
  double phi2 = acos(r/sqrt(d2));

  // trouver le minimum parmi les quatre cas
  double cas, meilleur;
  meilleur = fabs(plus(plus(theta1,phi1), -plus(theta2,phi2)));
  cas = fabs(plus(plus(theta1,phi1), -plus(theta2,-phi2)));
  if (cas < meilleur)
    meilleur = cas;
  cas = fabs(plus(plus(theta1,-phi1), -plus(theta2,phi2)));
  if (cas < meilleur)
    meilleur = cas;
  cas = fabs(plus(plus(theta1,-phi1), -plus(theta2,-phi2)));
  if (cas < meilleur)
    meilleur = cas;

  return tangente1+tangente2+r*meilleur;
}

int main()
{
  int N;
  double x1, x2, y1, y2, r, longueur;

  std::cin >> N;

  for (int i=0; i<N; ++i)
    {
      std::cin >> x1 >> y1 >> x2 >> y2 >> r;
      if (segment_inter_cercle(x1,x2,y1,y2,r))
	longueur = calcule_longueur(x1,x2,y1,y2,r);
      else
	longueur = sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
      printf("%.3f\n", longueur);
    }
}
