// Trees on my island. UVa 10088.

// On utilise la formule de l'aire signee et celle de Pick pour determiner le
// nombre de points a l'interieur d'un polygone.

// On n'utilise pas de tableau pour stocker les points : le premier point, le
// point en cours et le point precedent suffisent.

#include <iostream>
#include <stdint.h>

int64_t abs64(int64_t a)
{
  if (a>=0)
    return a;
  else
    return -a;
}

int64_t pgcd (int64_t a, int64_t b)
{
  int64_t r;

  while (b > 0) {
    r = a % b;
    a = b;
    b = r;
  }
  return a;
}

int main()
{

  int nb_sommets;
  int64_t sommet_en_cours[2], ancien_sommet[2], premier_sommet[2];
  int64_t nb_interieur, aire_signee;
  int64_t delta_x, delta_y;

  std::cin >> nb_sommets;

  while (nb_sommets != 0)
    {
      std::cin >> premier_sommet[0] >> premier_sommet[1];
      std::cin >> sommet_en_cours[0] >> sommet_en_cours[1];
      aire_signee = sommet_en_cours[0]*premier_sommet[1]
	-sommet_en_cours[1]*premier_sommet[0];
      delta_x = abs64(sommet_en_cours[0]-premier_sommet[0]);
      delta_y = abs64(sommet_en_cours[1]-premier_sommet[1]);
      nb_interieur = pgcd(delta_x, delta_y);
      for (int i=0; i<nb_sommets-2; ++i)
	{
	  ancien_sommet[0] = sommet_en_cours[0];
	  ancien_sommet[1] = sommet_en_cours[1];
	  std::cin >> sommet_en_cours[0] >> sommet_en_cours[1];
	  aire_signee += sommet_en_cours[0]*ancien_sommet[1]
	    -sommet_en_cours[1]*ancien_sommet[0];
	  delta_x = abs64(sommet_en_cours[0]-ancien_sommet[0]);
	  delta_y = abs64(sommet_en_cours[1]-ancien_sommet[1]);
	  nb_interieur += pgcd(delta_x, delta_y);
	}
      aire_signee += sommet_en_cours[1]*premier_sommet[0]
	-sommet_en_cours[0]*premier_sommet[1];
      delta_x = abs64(sommet_en_cours[0]-premier_sommet[0]);
      delta_y = abs64(sommet_en_cours[1]-premier_sommet[1]);
      nb_interieur += pgcd(delta_x, delta_y);

      std::cout << (abs64(aire_signee)-nb_interieur)/2+1 << std::endl;
      std::cin >> nb_sommets;
    }
}
